/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package za.co.enerweb.enygma.businesslogic.staging;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;
import za.co.enerweb.enygma.database.staging.StagingUom;

/**
 *
 * @author richard
 */
@Stateless
public class StagingUomFacade implements StagingUomFacadeLocal {
    @PersistenceContext(unitName = "EnygmaStaging")
    private EntityManager em;

    public void create(StagingUom stagingUom) {
        em.persist(stagingUom);
    }

    public void edit(StagingUom stagingUom) {
        em.merge(stagingUom);
    }

    public void remove(StagingUom stagingUom) {
        em.remove(em.merge(stagingUom));
    }

    public StagingUom find(Object id) {
        return em.find(StagingUom.class, id);
    }

    public List<StagingUom> findAll() {
        CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
        cq.select(cq.from(StagingUom.class));
        return em.createQuery(cq).getResultList();
    }

    public List<StagingUom> findRange(int[] range) {
        CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
        cq.select(cq.from(StagingUom.class));
        Query q = em.createQuery(cq);
        q.setMaxResults(range[1] - range[0]);
        q.setFirstResult(range[0]);
        return q.getResultList();
    }

    public int count() {
        CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
        Root<StagingUom> rt = cq.from(StagingUom.class);
        cq.select(em.getCriteriaBuilder().count(rt));
        Query q = em.createQuery(cq);
        return ((Long) q.getSingleResult()).intValue();
    }

}
